#include <stdio.h>

#define SP_VALVE_OPEN	1
#define SP_VALVE_CLOSE -1

class Panel;
class InstrumentDescriptor;
class CustomVariable;
class GDI_resources;
class VESSEL;
class E_system;
class H_system;
class Thermal_engine;
class VesselMgmt;
class PanelSDK

{
public:

	PanelSDK();
	~PanelSDK();
	void RegisterVessel(VESSEL *vessel);
	void RegisterPanel(int PanelID,char *name);
	void RegisterCustomPointer(char *PointerName,void* point);
	void RegisterCustomInstrument(char *ClassName,void* NewInst(char*,Panel*));
	void RegisterSwitchCodeFunction(void* CodeFunc(int));
    void *GetPointerByString(char *query);
	
	void InitFromFile(char *FileName);
//	char* ReadConfigLine();
    //char* ReadResourceLine();
	//void  BuildError(int err);


	bool LoadPanel(int id);
	void PanelEvent(int id,int event,SURFHANDLE surf);
	void MouseEvent(int id,int event,int mx,int my);
	int  KeybEvent(DWORD key,char *kstate);
	void MFDEvent(int mfd);
	void Timestep(double time);
	void SetStage(int stage,int load);
	
	void Load(FILEHANDLE scn);
	void Save(FILEHANDLE scn);
	void ShutDown();

	int CurentStage;
private:
	Panel *panels[10];	//up to 10 panels can be defined
	VESSEL* v;
	InstrumentDescriptor *InstDescriptor;
	CustomVariable *CustomVarList;
	
	E_system *ELECTRIC;
	H_system *HYDRAULIC;
	Thermal_engine *THERMAL;
    VesselMgmt *VESSELMGMT;
    
   
	//loads up the PRD file
	void PanelResources(char *FileName);	
	//creates a panel from the cfg file 
	void DoPanel(char *PanelName);
	
	 //adds up a instrument "type" 
	void AddDescriptor(InstrumentDescriptor *new_desc);
	InstrumentDescriptor* GetInstrumentDescriptor(char *line);

	int AddBitmapResource(char *BitmapName);
	int AddFontResource(char *FontName,int size);
	int AddBrushResource(int red,int green, int blue);
	int NumPanels;
	int Current_Panel;
	GDI_resources *GDI_res;	//panel SDK holds the resources

};